﻿using Jypeli;

namespace HangryDog;

/// @author  Vesa Lappalainen, kuvat ja äänet: Panu Lappalainen
/// @version 24.10.2014
/// <summary>
/// Esimerkki luokista ja perinnästä
/// </summary>
public class HangryDog : PhysicsGame
{
    public override void Begin()
    {
        Koira koira = new Koira(this, 200, Vector.Zero, "Musti");
        // Koira pluto = new Koira(this, 100, new Vector(300,300), "Pluto");
        LuoOhjaimet(koira, 300, Key.Up, Key.Down, Key.Left, Key.Right);

        Kissa kissa = new Kissa(this, 200, new Vector(100, 200), "Mirri");

        LuoOhjaimet(kissa, 300, Key.W, Key.Z, Key.A, Key.S);

        // var s = new PhysicsObject(10, 2000);
        // s.MakeStatic();
        // Add(s);

        Timer timer = new Timer();
        timer.Interval = 1.500;
        timer.Timeout += LuoRuokaa;
        timer.Start();

        LuoRuokaa();

        Level.CreateBorders();

        PhoneBackButton.Listen(ConfirmExit, "Lopeta peli");
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
        Keyboard.Listen(Key.F1, ButtonState.Pressed, ShowControlHelp, "Avustus");

        Camera.ZoomToLevel();
        // LoadImage("");
    }


    void LuoOhjaimet(Elain elain, double voima, Key up, Key down, Key left, Key right)
    {
        Keyboard.Listen(up, ButtonState.Down, elain.Liiku, elain.Nimi + " up", new Vector(0, voima));
        Keyboard.Listen(down, ButtonState.Down, elain.Liiku, elain.Nimi + " down", new Vector(0, -voima));
        Keyboard.Listen(left, ButtonState.Down, elain.Liiku, elain.Nimi + " left", new Vector(-voima, 0));
        Keyboard.Listen(right, ButtonState.Down, elain.Liiku, elain.Nimi + " right", new Vector(voima, 0));
    }


    void LuoRuokaa()
    {
        // var luu = new Luu(this, 50, 20, RandomGen.NextVector(Level.BoundingRect));
        var juusto = new Juusto(this, 50, RandomGen.NextVector(Level.BoundingRect));
        var _ = new Hiiri(this, 70, RandomGen.NextVector(Level.BoundingRect), juusto);
    }
}
